Codeforces Contest 1093 problem G Multidimensional Queries —— 枚举+线段树

本文主要是介绍Codeforces Contest 1093 problem G Multidimensional Queries —— 枚举+线段树,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

You are given an array a of n points in k-dimensional space. Let the distance between two points ax and ay be ∑i=1k|ax,i−ay,i| (it is also known as Manhattan distance).

You have to process q queries of the following two types:

1 i b1 b2 … bk — set i-th element of a to the point (b1,b2,…,bk);
2 l r — find the maximum distance between two points ai and aj, where l≤i,j≤r.
Input
The first line contains two numbers n and k (1≤n≤2⋅105, 1≤k≤5) — the number of elements in a and the number of dimensions of the space, respectively.

Then n lines follow, each containing k integers ai,1, ai,2, …, ai,k (−106≤ai,j≤106) — the coordinates of i-th point.

The next line contains one integer q (1≤q≤2⋅105) — the number of queries.

Then q lines follow, each denoting a query. There are two types of queries:

1 i b1 b2 … bk (1≤i≤n, −106≤bj≤106) — set i-th element of a to the point (b1,b2,…,bk);
2 l r (1≤l≤r≤n) — find the maximum distance between two points ai and aj, where l≤i,j≤r.
There is at least one query of the second type.

Output
Print the answer for each query of the second type.

Example
inputCopy
5 2
1 2
2 3
3 4
4 5
5 6
7
2 1 5
2 1 3
2 3 5
1 5 -1 -2
2 1 5
1 4 -1 -2
2 1 5
outputCopy
8
4
4
12
10

题意:

给你n个k维的点,两个点之间的距离是曼哈顿距离,给你m个询问
2 l r 表示询问l到r之间距离最长的两个点的距离是多少
1x p1-pk 将x位置的点换成这个

题解:

对于一个点来说,它到另一个点的距离有两种情况:x1-x2,-(x1-x2),然后k只有5,所以总共只有32种情况,其中最大的那个就是这两个k维点的距离,那么我们只需要开32个线段树,每一个线段树记录不同符号的情况,维护一个最大值和最小值,那么最大距离就是最大值减最小值。

#include<bits/stdc++.h>
using namespace std;
const int N=2e5+5;
const int inf=1e9+7;
int n,k;
int maxn[N*4][32],minn[N*4][32],x[10];
void pushup(int b,int root)
{maxn[root][b]=max(maxn[root<<1][b],maxn[root<<1|1][b]);minn[root][b]=min(minn[root<<1][b],minn[root<<1|1][b]);
}
void update(int b,int l,int r,int root,int pos,int val)
{if(l==r){maxn[root][b]=minn[root][b]=val;return ;}int mid=l+r>>1;if(mid>=pos)update(b,l,mid,root<<1,pos,val);elseupdate(b,mid+1,r,root<<1|1,pos,val);pushup(b,root);
}
int qmax(int b,int l,int r,int root,int ql,int qr)
{if(l>=ql&&r<=qr)return maxn[root][b];int mid=l+r>>1;int ans=-inf;if(mid>=ql)ans=max(ans,qmax(b,l,mid,root<<1,ql,qr));if(mid<qr)ans=max(ans,qmax(b,mid+1,r,root<<1|1,ql,qr));return ans;
}
int qmin(int b,int l,int r,int root,int ql,int qr)
{if(l>=ql&&r<=qr)return minn[root][b];int mid=l+r>>1;int ans=inf;if(mid>=ql)ans=min(ans,qmin(b,l,mid,root<<1,ql,qr));if(mid<qr)ans=min(ans,qmin(b,mid+1,r,root<<1|1,ql,qr));return ans;
}
int main()
{scanf("%d%d",&n,&k);int bitk=(1<<k)-1;for(int i=0;i<=n*4;i++)for(int j=0;j<=bitk;j++)maxn[i][j]=-inf,minn[i][j]=inf;for(int i=1;i<=n;i++){for(int j=0;j<k;j++)scanf("%d",&x[j]);for(int j=0;j<=bitk;j++){int sum=0;for(int l=0;l<k;l++){if((j&(1<<l)))sum+=x[l];elsesum-=x[l];}update(j,1,n,1,i,sum);}}int m;scanf("%d",&m);while(m--){int op;scanf("%d",&op);if(op==2){int l,r;scanf("%d%d",&l,&r);int ans=-inf;for(int i=0;i<=bitk;i++)ans=max(ans,abs(qmax(i,1,n,1,l,r)-qmin(i,1,n,1,l,r)));printf("%d\n",ans);}else{int pos;scanf("%d",&pos);for(int i=0;i<k;i++)scanf("%d",&x[i]);for(int j=0;j<=bitk;j++){int sum=0;for(int l=0;l<k;l++){if((j&(1<<l)))sum+=x[l];elsesum-=x[l];}update(j,1,n,1,pos,sum);}}}return 0;
}

这篇关于Codeforces Contest 1093 problem G Multidimensional Queries —— 枚举+线段树的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/881260

相关文章

csu 1446 Problem J Modified LCS (扩展欧几里得算法的简单应用)

这是一道扩展欧几里得算法的简单应用题,这题是在湖南多校训练赛中队友ac的一道题,在比赛之后请教了队友,然后自己把它a掉 这也是自己独自做扩展欧几里得算法的题目 题意:把题意转变下就变成了:求d1*x - d2*y = f2 - f1的解,很明显用exgcd来解 下面介绍一下exgcd的一些知识点:求ax + by = c的解 一、首先求ax + by = gcd(a,b)的解 这个

poj3468(线段树成段更新模板题)

题意:包括两个操作:1、将[a.b]上的数字加上v;2、查询区间[a,b]上的和 下面的介绍是下解题思路: 首先介绍  lazy-tag思想:用一个变量记录每一个线段树节点的变化值,当这部分线段的一致性被破坏我们就将这个变化值传递给子区间,大大增加了线段树的效率。 比如现在需要对[a,b]区间值进行加c操作,那么就从根节点[1,n]开始调用update函数进行操作,如果刚好执行到一个子节点,

hdu1394(线段树点更新的应用)

题意:求一个序列经过一定的操作得到的序列的最小逆序数 这题会用到逆序数的一个性质,在0到n-1这些数字组成的乱序排列,将第一个数字A移到最后一位,得到的逆序数为res-a+(n-a-1) 知道上面的知识点后,可以用暴力来解 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#in

hdu1689(线段树成段更新)

两种操作:1、set区间[a,b]上数字为v;2、查询[ 1 , n ]上的sum 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdl

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

uva 10025 The ? 1 ? 2 ? ... ? n = k problem(数学)

题意是    ?  1  ?  2  ?  ...  ?  n = k 式子中给k,? 处可以填 + 也可以填 - ,问最小满足条件的n。 e.g k = 12  - 1 + 2 + 3 + 4 + 5 + 6 - 7 = 12 with n = 7。 先给证明,令 S(n) = 1 + 2 + 3 + 4 + 5 + .... + n 暴搜n,搜出当 S(n) >=

hdu 2489 (dfs枚举 + prim)

题意: 对于一棵顶点和边都有权值的树,使用下面的等式来计算Ratio 给定一个n 个顶点的完全图及它所有顶点和边的权值,找到一个该图含有m 个顶点的子图,并且让这个子图的Ratio 值在所有m 个顶点的树中最小。 解析: 因为数据量不大,先用dfs枚举搭配出m个子节点,算出点和,然后套个prim算出边和,每次比较大小即可。 dfs没有写好,A的老泪纵横。 错在把index在d

poj 1127 线段相交的判定

题意: 有n根木棍,每根的端点坐标分别是 px, py, qx, qy。 判断每对木棍是否相连,当他们之间有公共点时,就认为他们相连。 并且通过相连的木棍相连的木棍也是相连的。 解析: 线段相交的判定。 首先,模板中的线段相交是不判端点的,所以要加一个端点在直线上的判定; 然后,端点在直线上的判定这个函数是不判定两个端点是同一个端点的情况的,所以要加是否端点相等的判断。 最后

HDU4737线段树

题目大意:给定一系列数,F(i,j)表示对从ai到aj连续求或运算,(i<=j)求F(i,j)<=m的总数。 const int Max_N = 100008 ;int sum[Max_N<<2] , x[Max_N] ;int n , m ;void push_up(int t){sum[t] = sum[t<<1] | sum[t<<1|1] ;}void upd